HDU 6143 Killer Names

昨天的多校应该是团队合作最失败的一次……

一开始过题人数最多的那道题许颂嘉没去想,只能我自己上了,第一直觉就是DP,但这个状态转移真的想了我好久好久,但想出来后又觉得是非常显然的……

后来不知道什么时候许学姐来想这题了,估计是急了,也没跟我说,然后就是两个人单独想题的局面,还瞒着我敲了一发容斥……是的,一个队里两个人同时用两种算法在想同一题。这是团队赛最忌讳的。
也可以说是最愚蠢的。

之后敲完之后雨情学姐又给了我一个错误数据,先是打乱我的思路,然后debug了将近一个小时,发现数据错误之后,把最开始的代码交了一发就秒了……

不想多说什么,这场明明还有一道很简单的细心题,当时急了,没发现重点。和一道几乎是AC自动机入门题的题,没看。

我特么 心如刀割。

题意:
给你一个长度( n\和字符数量( m),让你组成两个字符串,两个字符串两两不能有统一字符。

思路:
标程是容斥,我不会,这题提供DP解法。
令( dp[ len ] [ num ] ) 表示长度为( len ) 的字符串并且有( num )个字符的数量。
那么我现在只考虑一个字符串,它的长度固定为( n),我用 ( num) 个字符去组成它,那么对于剩下可选的( m – num )个字符,任意组成另一个字符串。
这里所谓另一个字符串是可以直接求并且很好求的,就是( ( m – num )^n )。自己去体会啦
而( dp [ len ] [ num ] )可以通过如下转移方程求解。

$ dp[ len ] [ num ] = dp[ len – 1 ] [ num – 1 ] \times ( m – num + 1 ) + dp [ len – 1 ] [ num ] \times num $

略加思考就能体会到这个转移方程的正确性,这里就不说了。

AC Code

#include<iostream>
#include<cstdio>
#include<cstring>
#include<cmath>
#include<string>
#include<algorithm>
#include<queue>
#include<stack>
#include<set>
#include<map>
#include<vector>
using namespace std;
typedef long long ll;

const int mod = 1e9+7;
const int maxn = 2e3+5;

int n,m;
ll dp[maxn][maxn];

ll fastPow(ll n,ll m)
{
    ll ans=1;
    while (m)
    {
        if (m&1)
            ans=ans*n%mod;
        n=n*n%mod;
        m>>=1;
    }
    return ans;
}

int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d %d",&n,&m);
        for(int len=1; len<=n; len++)
            dp[len][1]= m ;
        for(int num=2; num<=m; num++)
            dp[1][num] = 0;
        for(int len=2; len<=n; len++)
            for(int num=2; num<=m; num++)
                dp[len][num] = ((dp[len-1][num-1]*(m-num+1))%mod+(dp[len-1][num]*num)%mod)%mod;
        ll ans = 0;
        for(int num=1; num<m; num++)
            ans = (ans+dp[n][num] * fastPow(m-num,n))%mod;
        printf("%lld\n",ans);
    }
    return 0;
}